//+------------------------------------------------------------------+
//|                             chande_momentum_oscillatorSignal.mqh |
//|                                                    2011, etrader |
//|                                             http://efftrading.ru |
//+------------------------------------------------------------------+
#property copyright "2011, etrader"
#property link      "http://efftrading.ru"
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
#include <Expert\ExpertSignal.mqh>
#define INDICATOR_CMO_FILENAME "chande_momentum_oscillator.ex5"
#property tester_indicator INDICATOR_CMO_FILENAME
#include <Expert\Signal\MySignals\BasedOnIndicatorExpertSignal.mqh>
// wizard description start
//+------------------------------------------------------------------+
//| Description of the class                                         |
//| Title=Signal based on Chande Momentum Oscillator                 |
//| Type=SignalAdvanced                                              |
//| Name=Chande_Momentum_Oscillator                                  |
//| Class=CChande_Momentum_Oscillator                                |
//| Page=                                                            |
//| Parameter=CMO_period,int,9,period of CMO                         |
//| Parameter=CMO_Shift,int,0,horizontal shift in bars               |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
// wizard description end
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|   CChande_Momentum_Oscillator                               |
//| :               |
//|             chande_momentum_oscillator                 |
//|            http://www.mql5.com/ru/code/411                       |  
//+------------------------------------------------------------------+
class CChande_Momentum_Oscillator: public CBasedOnIndicatorExpertSignal{
  private: 
   int m_cmo_period; // CMO
   int m_cmo_shift ; //     |
  public:
   virtual int       ShortCondition();      //   
   virtual int       LongCondition();       //   
   virtual void      FillParameters();      //    m_parameters
//---   CMO   
   void              CMO_period( int passedvalue ){ m_cmo_period = passedvalue;}  
//---       
   void              CMO_Shift( int passedvalue ) { m_cmo_shift = passedvalue;}  
};


//+------------------------------------------------------------------+
//|                      |
//| INPUT:                                                        |
//| OUTPUT:                                                       |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
void CChande_Momentum_Oscillator::FillParameters(void){
//---   3 -  
  ArrayResize(m_parameters, 3 );
//---  
  m_parameters[0].type         = TYPE_STRING;      
  m_parameters[0].string_value = INDICATOR_CMO_FILENAME; 
//---  CMO_period
  m_parameters[1].type         = TYPE_INT;      
  m_parameters[1].integer_value = m_cmo_period; 
//---  CMO_period
  m_parameters[2].type         = TYPE_INT;      
  m_parameters[2].integer_value= m_cmo_shift; 
}

//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CChande_Momentum_Oscillator::ShortCondition(){
//---      0
//---     50     
   if( m_indicator.GetData( 0, 1 ) > 50  && m_indicator.GetData(0, 2 )<= 50 )   return( 100 );
//---      
   return(0); 
}


//+------------------------------------------------------------------+
//|                               |
//| INPUT:                                                        |
//| OUTPUT:    0  100                                   |
//| REMARK: .                                                     |
//+------------------------------------------------------------------+
int CChande_Momentum_Oscillator::LongCondition(){
//---      0
//---     -50   
   if( m_indicator.GetData( 0, 1 ) < -50  && m_indicator.GetData(0, 2 )>= -50 )   return( 100 );
//---      
   return(0); 
}

//+------------------------------------------------------------------+